package model

type Parkinglot struct {
	Name       string `json:"name"`
	StartSpace string `json:"startSpace"`
	StopSpace  string `json:"stopSpace"`
	Timeout    string `json:"timeout"`
}

// Event:ParkedCall
// ParkeeAccountCode:
// ParkeeCallerIDName:106
// ParkeeCallerIDNum:106
// ParkeeChannel:PJSIP/106-00000171
// ParkeeChannelState:6
// ParkeeChannelStateDesc:Up
// ParkeeConnectedLineName:120
// ParkeeConnectedLineNum:120
// ParkeeContext:macro-stdexten
// ParkeeExten:s
// ParkeeLanguage:en
// ParkeeLinkedid:1621821838.695
// ParkeePriority:26
// ParkeeUniqueid:1621821838.695
// ParkerDialString:PJSIP/106
// ParkingDuration:113
// ParkingSpace:41
// ParkingTimeout:487
// Parkinglot:default

type ParkedCall struct {
	Event                   string `json:"event"`
	ParkeeCallerIDName      string `json:"parkeeCallerIDName"`
	ParkeeCallerIDNum       string `json:"parkeeCallerIDNumber"`
	ParkeeChannel           string `json:"parkeeChannel"`
	ParkeeChannelState      string `json:"parkeeChannelState"`
	ParkeeChannelStateDesc  string `json:"parkeeChannelStateDesc"`
	ParkeeConnectedLineName string `json:"parkeeConnectedLineName"`
	ParkeeConnectedLineNum  string `json:"parkeeConnectedLineNumber"`
	ParkeeContext           string `json:"parkeeContext"`
	ParkeeExten             string `json:"parkeeExten"`
	ParkeeLanguage          string `json:"parkeeLanguage"`
	ParkeeLinkedid          string `json:"parkeeLinkedid"`
	ParkeePriority          string `json:"parkeePriority"`
	ParkeeUniqueid          string `json:"parkeeUniqueid"`
	ParkerDialString        string `json:"parkerDialString"`
	ParkingDuration         string `json:"parkingDuration"`
	ParkingSpace            string `json:"parkingSpace"`
	ParkingTimeout          string `json:"parkingTimeout"`
	Parkinglot              string `json:"parkinglot"`
}

// Event:UnParkedCall
// ParkeeAccountCode: ParkeeCallerIDName:106
// ParkeeCallerIDNum:106
// ParkeeChannel:PJSIP/106-000001a0
// ParkeeChannelState:6
// ParkeeChannelStateDesc:Up
// ParkeeConnectedLineName:120
// ParkeeConnectedLineNum:120
// ParkeeContext:macro-stdexten
// ParkeeExten:s
// ParkeeLanguage:en
// ParkeeLinkedid:1621835298.828
// ParkeePriority:26
// ParkeeUniqueid:1621835298.828
// ParkerDialString:PJSIP/106
// ParkingDuration:12
// ParkingSpace:41
// ParkingTimeout:588
// Parkinglot:default
// Privilege:call,all
// RetrieverAccountCode:
// RetrieverCallerIDName:119
// RetrieverCallerIDNum:119
// RetrieverChannel:PJSIP/119-000001a2
// RetrieverChannelState:6
// RetrieverChannelStateDesc:Up
// RetrieverConnectedLineName:<unknown>
// RetrieverConnectedLineNum:<unknown>
// RetrieverContext:DialPlan1
// RetrieverExten:41
// RetrieverLanguage:en
// RetrieverLinkedid:1621835340.830
// RetrieverPriority:1
// RetrieverUniqueid:1621835340.830
// Timestamp:1621835340.214037

type UnParkedCall struct {
	Event                   string `json:"event"`
	ParkeeCallerIDName      string `json:"parkeeCallerIDName"`
	ParkeeCallerIDNum       string `json:"parkeeCallerIDNumber"`
	ParkeeChannel           string `json:"parkeeChannel"`
	ParkeeChannelState      string `json:"parkeeChannelState"`
	ParkeeChannelStateDesc  string `json:"parkeeChannelStateDesc"`
	ParkeeConnectedLineName string `json:"parkeeConnectedLineName"`
	ParkeeConnectedLineNum  string `json:"parkeeConnectedLineNumber"`
	ParkeeContext           string `json:"parkeeContext"`
	ParkeeExten             string `json:"parkeeExten"`
	ParkeeLanguage          string `json:"parkeeLanguage"`
	ParkeeLinkedid          string `json:"parkeeLinkedid"`
	ParkeePriority          string `json:"parkeePriority"`
	ParkeeUniqueid          string `json:"parkeeUniqueid"`
	ParkerDialString        string `json:"parkerDialString"`
	ParkingDuration         string `json:"parkingDuration"`
	ParkingSpace            string `json:"parkingSpace"`
	ParkingTimeout          string `json:"parkingTimeout"`
	Parkinglot              string `json:"parkinglot"`
}

// Event: ParkedCallTimeOut
// ParkeeAccountCode: <value>
// ParkeeCallerIDName: <value>
// ParkeeCallerIDNum: <value>
// ParkeeChannel: <value>
// ParkeeChannelState: <value>
// ParkeeChannelStateDesc: <value>
// ParkeeConnectedLineName: <value>
// ParkeeConnectedLineNum: <value>
// ParkeeContext: <value>
// ParkeeExten: <value>
// ParkeeLanguage: <value>
// ParkeeLinkedid: <value>
// ParkeePriority: <value>
// ParkeeUniqueid: <value>
// ParkerAccountCode: <value>
// ParkerCallerIDName: <value>
// ParkerCallerIDNum: <value>
// ParkerChannel: <value>
// ParkerChannelState: <value>
// ParkerChannelStateDesc: <value>
// ParkerConnectedLineName: <value>
// ParkerConnectedLineNum: <value>
// ParkerContext: <value>
// ParkerDialString: <value>
// ParkerExten: <value>
// ParkerLanguage: <value>
// ParkerLinkedid: <value>
// ParkerPriority: <value>
// ParkerUniqueid: <value>
// ParkingDuration: <value>
// ParkingSpace: <value>
// ParkingTimeout: <value>
// Parkinglot: <value>
type ParkedCallTimeOut struct {
	Event                   string `json:"event"`
	ParkeeCallerIDName      string `json:"parkeeCallerIDName"`
	ParkeeCallerIDNum       string `json:"parkeeCallerIDNumber"`
	ParkeeChannel           string `json:"parkeeChannel"`
	ParkeeChannelState      string `json:"parkeeChannelState"`
	ParkeeChannelStateDesc  string `json:"parkeeChannelStateDesc"`
	ParkeeConnectedLineName string `json:"parkeeConnectedLineName"`
	ParkeeConnectedLineNum  string `json:"parkeeConnectedLineNumber"`
	ParkeeContext           string `json:"parkeeContext"`
	ParkeeExten             string `json:"parkeeExten"`
	ParkeeLanguage          string `json:"parkeeLanguage"`
	ParkeeLinkedid          string `json:"parkeeLinkedid"`
	ParkeePriority          string `json:"parkeePriority"`
	ParkeeUniqueid          string `json:"parkeeUniqueid"`
	ParkerDialString        string `json:"parkerDialString"`
	ParkingDuration         string `json:"parkingDuration"`
	ParkingSpace            string `json:"parkingSpace"`
	ParkingTimeout          string `json:"parkingTimeout"`
	Parkinglot              string `json:"parkinglot"`
}

// Event: ParkedCallGiveUp
// ParkeeAccountCode:
// ParkeeCallerIDName: 106
// ParkeeCallerIDNum: 106
// ParkeeChannel: PJSIP/106-00000191
// ParkeeChannelState: 6
// ParkeeChannelStateDesc: Up
// ParkeeConnectedLineName: 120
// ParkeeConnectedLineNum: 120
// ParkeeContext: macro-stdexten
// ParkeeExten: s
// ParkeeLanguage: en
// ParkeeLinkedid: 1621827325.781
// ParkeePriority: 26
// ParkeeUniqueid: 1621827325.781
// ParkerDialString: PJSIP/106
// ParkingDuration: 48
// ParkingSpace: 41
// ParkingTimeout: 552
// Parkinglot: default
// Privilege: call,all
// Timestamp: 1621827421.460917

type ParkedCallGiveUp struct {
	Event                   string `json:"event"`
	ParkeeCallerIDName      string `json:"parkeeCallerIDName"`
	ParkeeCallerIDNum       string `json:"parkeeCallerIDNumber"`
	ParkeeChannel           string `json:"parkeeChannel"`
	ParkeeChannelState      string `json:"parkeeChannelState"`
	ParkeeChannelStateDesc  string `json:"parkeeChannelStateDesc"`
	ParkeeConnectedLineName string `json:"parkeeConnectedLineName"`
	ParkeeConnectedLineNum  string `json:"parkeeConnectedLineNumber"`
	ParkeeContext           string `json:"parkeeContext"`
	ParkeeExten             string `json:"parkeeExten"`
	ParkeeLanguage          string `json:"parkeeLanguage"`
	ParkeeLinkedid          string `json:"parkeeLinkedid"`
	ParkeePriority          string `json:"parkeePriority"`
	ParkeeUniqueid          string `json:"parkeeUniqueid"`
	ParkerDialString        string `json:"parkerDialString"`
	ParkingDuration         string `json:"parkingDuration"`
	ParkingSpace            string `json:"parkingSpace"`
	ParkingTimeout          string `json:"parkingTimeout"`
	Parkinglot              string `json:"parkinglot"`
}
